#include <ctime>
#include <string.h>
//#include <iostream>
#include <fstream>
#include <sstream> 
#include <ilcplex/ilocplex.h>  


ILOSTLBEGIN

//using namespace std;
const double EPS = 10e-6;

int main(int argc, char **argv)
{
	const int n = 10;
	int T[n][n];
	int Res[n][n];

	string nom = "..\\data.txt";
	std::ifstream f(nom.c_str());
	string ligne;

	for (int i = 0; i < n; i++)
	{
		for (int j = 0; j < 10; j++)
		{
			int valeur;
			f >> valeur;
			T[i][j] = valeur;
		}
	}

	f.close();


	try {

		IloEnv env;
		IloModel model(env, "Demonstration");

		IloNumVar obj;
		obj = IloIntVar(env, 0.0, 1000,"objectif");

		typedef IloArray<IloIntVarArray> T_Matrice;

		T_Matrice x(env, n);
		for (int i = 0; i < n; i++)
		{
			x[i] = IloIntVarArray(env, n);
		}


		for (int i = 0; i < n; i++)
		{
			for (int j = 0; j < n; j++)
			{
				stringstream ss;
				ss << "x_" << i << "_" <<j;
				string str = ss.str();
				x[i][j] = IloIntVar(env, 0.0, 1, str.c_str());
			}
		}





		int numero = 0;

		// ajout de la contrainte 1.
		// -------------------------
		IloRangeArray cover(env);

		for (int i = 0; i < n; i++)
		{
			IloNumExpr expr(env);

			for (int j = 0; j < n; j++)
			{
				expr = expr + x[i][j];
			}

			stringstream ss;
			ss << "C" << numero;
			string str = ss.str();

			IloRange r1(env, 1, expr, 1, str.c_str());
			cover.add(r1);

			numero++;
		}

		//model.add(cover);

		// ajout de la contrainte 2.
		// -------------------------
//		IloRangeArray cover(env);

		for (int j = 0; j < n; j++)
		{
			IloNumExpr expr(env);

			for (int i = 0; i < n; i++)
			{
				expr = expr + x[i][j];
			}

			stringstream ss;
			ss << "C" << numero;
			string str = ss.str();

			IloRange r1(env, 1, expr, 1, str.c_str());
			cover.add(r1);

			numero++;
		}

		//model.add(cover);


		// ajout de la contrainte 3.
		// -------------------------
		//IloRangeArray cover(env);

		for (int i = 0; i < n; i++)
		{
			IloNumExpr expr(env);
			expr = expr + x[i][i];

			stringstream ss;
			ss << "C" << numero;
			string str = ss.str();

			IloRange r1(env, 0, expr, 0, str.c_str());
			cover.add(r1);

			numero++;
		}





		// definition de la fonction objectif
		// ----------------------------------
		IloNumExpr expr(env);
		expr = -obj;
		for (int i = 0; i < n; i++)
		{
			for (int j = 0; j < n; j++)
			{
				expr = expr + x[i][j]*T[i][j];
			}
		}

		stringstream ss;
		ss << "C" << numero;
		string str = ss.str();

		IloRange r1(env, 0, expr, 0, str.c_str());
		cover.add(r1);
		numero++;


		model.add(cover);

		// obj fonction
		model.add(IloMinimize(env, obj));



		int stop = 0;
		int iteration=0;
		int nb_sous_tour = 0;

		while (stop == 0)
		{
			nb_sous_tour = 0;
			iteration++;
			cout << "iteration numero " << iteration << endl;

			// verification : on enregistre sur le disque
			// -------------------------
			IloCplex cplex(env);
			cplex.extract(model);
			stringstream ss;
			ss << "Modele_" << iteration << ".lp";
			string str = ss.str();
			cplex.exportModel(str.c_str());

			// resolution
			cplex.solve();

			int lecout = cplex.getObjValue();

			cout << "cout de la sol. : " << lecout << endl;

			// recuperation solution et memorisation
			for (int i = 0; i < n; i++)
			{
				for (int j = 0; j < n; j++)
				{
					int valeur1 = (int)cplex.getValue(x[i][j]);
					Res[i][j] = valeur1;
				}
			}

			// affichage
			for (int i = 0; i < n; i++)
			{
				for (int j = 0; j < n; j++)
				{
					if (Res[i][j] > 0)
					{
						stringstream ss;
						ss << "x_" << i << "_" << j << " = ";
						string str = ss.str();

						ss << Res[i][j] << endl;

						cout << ss.str();
					}
				}
			}


			// recherche de cycle
			int liste[n+1];
		//	int nb_element = 0;

			for (int i = 0; i < n; i++)
			{
				for (int j = 0; j < n; j++)
				{
					if (Res[i][j] > 0)
					{
						// point de depart potentiel d'un cycle

						int i1 = i;
						int j1 = j;

						//nb_element = 0;
						int depart = i;

						int stop = 0;
						int nb_tour = 0;

						while ((stop == 0) && (nb_tour < n))
						{
							if (Res[i1][j1] > 0)
							{
								liste[nb_tour] = i1;
								nb_tour++;

								i1 = j1;
								j1 = 0;

								if (i1 == depart)
								{
									liste[nb_tour] = i1;
									nb_tour++;

									stop = 2;
								}

							}
							else
								if (j1 < n - 1)
									j1++;
								else
									stop = 1;
						}
						if (stop == 2)
						{
							nb_sous_tour++;
							IloNumExpr expr2(env);

							cout << "sous tour : ";
							for (int k = 0; k < nb_tour - 1; k++)
							{
								//stringstream ss;
								//ss << liste[k] << " ";

								//cout << ss.str();

								int depart = liste[k];
								int arrivee = liste[k + 1];

								//cout << endl;
								cout << depart << "/" << arrivee << " - " << endl;

								Res[depart][arrivee] = 0;

								expr2 = expr2 + x[depart][arrivee];

							}
							cout << endl;
							// ajout de la contrainte
							stringstream ss;
							ss << "C" << numero;
							string str = ss.str();
							IloRange r2(env, -IloInfinity, expr2, nb_tour - 2, str.c_str());
							IloRangeArray cover2(env);
							cover2.add(r2);
							model.add(cover2);
							numero++;

						}


					}
				}
			}



			if (nb_sous_tour == 1)
				stop = 1;

		} // fin du tant que

		
	}
	catch (IloException& e) {
		cerr << "Concert exception caught: " << e << endl;
	}
}
